#define MQ2pin (0)    //MQ-6 sul piedino 0 (analogico
#define LED_PIN (11)    //led su piedino 13 (+gnd)
#define BUZZER_PIN (13)  //buzzer (altoparlante piezo) su piedino 3 (+gnd)
int sensorDigitalPin = 2;
int  digitalValue;  

bool state = false;

float sensorValue;  //variable to store sensor value

void setup()

{
  pinMode(LED_PIN, OUTPUT);
  pinMode(BUZZER_PIN, OUTPUT);
  
  Serial.begin(9600); // setta la porta seriale a 9600
  Serial.println("Il sensore di gas si sta riscaldando!");
  delay(20000); // permette al MQ-6 di andare in temperatura (20 secondi)
}

void loop()
{
  sensorValue = analogRead(MQ2pin); // legge l'imput analogico sul pin 0
  digitalValue = digitalRead(sensorDigitalPin);
  Serial.print("Valore del sensore (ppm): ");
  Serial.print(sensorValue);
  Serial.print("  Digital Value: ");
  Serial.print(digitalValue);
  
  if(sensorValue > 300){
    if(!state){
      state = true;
  }
    Serial.print(" | RISCONTRATO FUMO O GAS!");     //se la concentrazione di gas supera 300 ppm, allora
    digitalWrite(LED_PIN, millis()/100%2);  //lampeggia il led
    tone(BUZZER_PIN, millis()%1000+200);    //il buzzer emette un suono variabile tra 1000 e 200 Hz
     }else{
      if(state){                            //quando torna sotto i 300 ppm
      digitalWrite(LED_PIN, LOW);           // spegne gli allarmi
      noTone(BUZZER_PIN);
      state = false;  
    }
  }
  Serial.println("");
  delay(150); // aspetta 150 mS prima di effettuare una nuova lettura
}
